package security;

import classUtils.pack.TestPack;
import com.jcraft.jsch.UserInfo;
import futils.In;
import net.ScpTo;
import utils.SystemUtils;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Date;
import java.util.jar.JarFile;

/**
 * DocJava, Inc. User: lyon Date: May 26, 2004
 * Time: 10:39:47 AM
 */
public class WebStartUtils {
    public static void main(String[] args) {
        packSignUploadJNLP("pavlik.AffineImagePanel");
    }

    public static void checkClass(
            String className) {
        try {
            Class.forName(className);
        } catch (ClassNotFoundException e) {
            futils.Out.messageDialog("Danger: I could not find" +
                                     className);
        }

    }

    public static void packSignUploadJNLP() {
        packSignUploadJNLP(futils.In.getString(
                "enter class name"));

    }

    public static void packSignUploadJNLP(
            String mainClassName) {
        checkClass(mainClassName);
        final File keyStoreFile =
                new File(
                        "/Users/lyon/current/java/j4p/keystore");
        //= futils.Futil.getReadFile(
        //"select keystore");
        String vendor = "DocJava, Inc.";
        String url = "http://www.docjava.com";
        final String alias = "docjava";

        final String password = In.getPassword(
                "enter keystore password");


        String codeBase = "http://show.docjava.com:8086/book/cgij/code/jnlp/";
        String iconUrl = "http://show.docjava.com:8086/consulti/docjava.jpe\"";


        String user = "lyon";
        String host = "192.168.1.95";
        final String rootDirectory = "/var/www/html/book/cgij/code/jnlp/";
        String jarFileName = mainClassName +
                             ".jar";


        packSignAndUpload(mainClassName,
                          jarFileName,
                          keyStoreFile,
                          password,
                          alias,
                          vendor,
                          url,
                          codeBase,
                          iconUrl,
                          user,
                          host,
                          rootDirectory);

    }

    public static void packSignOutputJnlp(
            final String mainClassName,
            final File keyStoreFile,
            final String password,
            final String alias,
            String vendor,
            String url) {
        String codeBase = "http://show.docjava.com:8086/book/cgij/code/jnlp/";
        String iconUrl = "http://show.docjava.com:8086/consulti/docjava.jpe\"";


        String user = "lyon";
        String host = "192.168.1.95";

        final String rootDirectory = "/var/www/html/book/cgij/code/jnlp/";
        String jarFileName = mainClassName +
                             ".jar";

        packSignAndUpload(mainClassName,
                          jarFileName,
                          keyStoreFile,
                          password,
                          alias,
                          vendor,
                          url,
                          codeBase,
                          iconUrl,
                          user,
                          host,
                          rootDirectory);

        //SignUtils.verify(jarFileName);
        verifyJar(jarFileName);

    }

    /**
     * Use the built-in JarVerifier class to
     * verify the existance and signing of the Jar
     * file.
     *
     * @param jarFileName
     */
    public static void verifyJar(
            String jarFileName) {
        try {
            new JarFile(jarFileName);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static void packSignAndUpload(
            final String mainClassName,
            String jarFileName,
            final File keyStoreFile,
            final String password,
            final String alias,
            String vendor,
            String url,
            String codeBase,
            String iconUrl,
            String user,
            String host,
            final String rootDirectory) {
        TestPack.pack(mainClassName,
                      jarFileName);

        SignUtils.sign(keyStoreFile + "",
                       password,
                       jarFileName,
                       alias);

        String title = mainClassName;
        String localCodeBase = keyStoreFile.getParent();

        String separator = SystemUtils.getFileSeparator();
        final File localJnlpFile = new File(localCodeBase +
                                            separator +
                                            mainClassName +
                                            ".local" +
                                            ".jnlp");
        final File jnlpFile = new File(localCodeBase +
                                       separator +
                                       mainClassName +
                                       ".jnlp");

        writeJnlp(title,
                  vendor,
                  url,
                  jarFileName,
                  mainClassName,
                  localJnlpFile,
                  localCodeBase);

        UserInfo ui = new ScpTo.MyUserInfo();
        upLoadJnlp(title,
                   vendor,
                   url,
                   jarFileName,
                   mainClassName,
                   jnlpFile,
                   codeBase,
                   iconUrl,
                   user,
                   host,
                   ui,
                   rootDirectory);
    }

    /**
     * Synthesize and upload the JNLP and Jar
     * files.
     *
     * @param title         Application title
     * @param vendor        Application owner
     * @param homePage
     * @param jarFileName   A packed jar file
     * @param mainClass     A fully qualified
     *                      class name
     * @param jnlpFile      The JNLP used for
     *                      launching
     * @param codeBase
     * @param iconUrl
     * @param user
     * @param host
     * @param ui
     * @param rootDirectory
     */
    public static void upLoadJnlp(String title,
                                  String vendor,
                                  String homePage,
                                  String jarFileName,
                                  String mainClass,
                                  File jnlpFile,
                                  String codeBase,
                                  String iconUrl,
                                  String user,
                                  String host,
                                  UserInfo ui,
                                  String rootDirectory) {

        String cmd =
                "<jnlp href=\"" +
                jnlpFile.getName() +
                "\" codebase=\"" +
                codeBase +
                "\">\n" +
                "  <information>\n" +
                "    <title>" + title +
                "</title>\n" +
                "    <vendor>" + vendor +
                "</vendor>\n" +
                "    <homepage href=\"" +
                homePage +
                "\"/>\n" +
                "<icon href=\"" + iconUrl +

                "/>" +
                "\n" +
                "    <offline-allowed />\n" +
                "  </information>\n" +
                "  \n" +
                "  <security>\n" +
                "    <all-permissions />\n" +
                "  </security>\n" +
                "  \n" +
                "  <resources>\n" +
                "    <j2se version=\"" +
                "1.4+" +
                "\" />\n" +
                "    <jar href=\"" +
                jarFileName +
                "\" />\n" +
                "  </resources>\n" +
                " \n" +
                "  <application-desc main-class=\"" +
                mainClass +
                "\" />\n" +
                "</jnlp>\n";

        try {


            uploadJnlp(jnlpFile,
                       cmd,
                       rootDirectory,
                       jarFileName,
                       user,
                       host,
                       ui);

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static void uploadJnlp(File jnlpFile,
                                   String cmd,
                                   final String rootDirectory,
                                   String jarFileName,
                                   String user,
                                   String host,
                                   UserInfo ui)
            throws IOException {
        saveToDisk(jnlpFile, cmd);
        String rJnlpFile = rootDirectory +
                           jnlpFile.getName();
        String rJarFile = rootDirectory +
                          jarFileName;

        ScpTo.scpTo(jnlpFile.toString(),
                    user,
                    host,
                    rJnlpFile,
                    ui);
        ScpTo.scpTo(jarFileName,
                    user,
                    host,
                    rJarFile,
                    ui);
        print("done with xfer at:" +
              new Date());
    }

    public static void print(Object o) {
        System.out.println(o);
    }

    public static void writeJnlp(String title,
                                 String vendor,
                                 String homePage,
                                 String jarFileName,
                                 String mainClass,
                                 File jnlpFile,
                                 String codeBase) {

        String cmd =
                "<jnlp href=\"" +
                jnlpFile.getName() +
                "\" codebase=\"file://" +
                codeBase +
                "\">\n" +
                "  <information>\n" +
                "    <title>" + title +
                "</title>\n" +
                "    <vendor>" + vendor +
                "</vendor>\n" +
                "    <homepage href=\"" +
                homePage +
                "\"/>\n" +
                "\n" +
                "    <offline-allowed />\n" +
                "  </information>\n" +
                "  \n" +
                "  <security>\n" +
                "    <all-permissions />\n" +
                "  </security>\n" +
                "  \n" +
                "  <resources>\n" +
                "    <j2se version=\"" +
                "1.4+" +
                "\" />\n" +
                "    <jar href=\"" +
                jarFileName +
                "\" />\n" +
                "  </resources>\n" +
                " \n" +
                "  <application-desc main-class=\"" +
                mainClass +
                "\" />\n" +
                "</jnlp>\n";

        try {
            saveToDisk(jnlpFile, cmd);

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static void saveToDisk(File jnlpFile,
                                   String cmd)
            throws IOException {
        System.out.println("output to:" +
                           jnlpFile +
                           "\n" +
                           cmd);

        FileWriter fw =
                new FileWriter(jnlpFile);

        fw.write(cmd);
        fw.write("\n");
        fw.close();
    }
}
